//--------------------------------------------
//  CLASSES : lists of integers  (2)
//--------------------------------------------
#include  <iostream.h> 
//--------------------------------------------
class cell
{public : 
   int atom; cell* next;
   cell(int at, cell* nx) : atom(at), next(nx) { }; // constructor 
};
typedef cell* list;

//---------------- head, tail, and cons functions ----
int head(list L)
{ if (L == NULL) {cout << "\n error: head of empty list \n"; }
  else {return L->atom;} ; }

list tail(list L)
{ if (L == NULL) {cout << "\n error: tail of empty list \n"; }
  else {return L->next;} ; }

list cons(int x, list L)
{list newlist = new cell(x,L) ; return newlist ;}

//------------------ member function ----------------
bool member(int e, list L)
{if (L == NULL) {return false;}
 else if (head(L) == e) {return true;}
 else {return member(e,tail(L));};
};

//------------------ print function ----------------
void printlist (list L)
{if (L == NULL) {cout << " nil"; return;}
 else {cout <<  head(L) << " ";  printlist(tail(L)); };
};

//--------------------------------------------
void main ()
{
list list1 = new cell (12,NULL);
cout << "\n list1 = "; printlist(list1);

list list2 = cons(44,list1); 
cout << "\n list2 = "; printlist(list2);

cout << "\n head(list2) = " << head(list2);
cout << "\n tail(list2) = " ;  printlist(tail(list2));
cout << "\n member(12,[44,12]) = " << member(12,list2);
cout << "\n member(13,[44,12]) = " << member(13,list2);
cout << "\n\n";
}
//--------------------------------------------
// input:   output:
//
//           list1 = 12  nil
//           list2 = 44 12  nil
//           head(list2) = 44
//           tail(list2) = 12  nil
//            
//--------------------------------------------
